<template>
  <div class="p-4">
    <BasicTable @register="registerTable" :rowSelection="{ type: 'checkbox' }">
      <template #toolbar>
        <a-button type="primary" @click="exportExcel"> 导出</a-button>
        <PopConfirmButton
          title="是否确定收货？"
          primary
          color="error"
          @confirm="handleConfirmReceive"
        >
          确定收货</PopConfirmButton
        >
      </template>
      <template #cover="{ record }">
        <TableImg :size="150" :simpleShow="true" :imgList="[record.cover]" />
      </template>
      <template #orderType="{ record }"> {{ renderOrderTypeLabel(record.orderType) }} </template>
      <template #orderStatus="{ record }">
        {{ renderOrderStatusLabel(record.orderStatus) }}
      </template>
      <template #shippingStatus="{ record }">
        {{ rendershippingStatusLabel(record.shippingStatus) }}
      </template>
      <template #payStatus="{ record }">
        {{ renderpayStatusLabel(record.payStatus) }}
      </template>
      <template #addTime="{ record }">
        <Time :value="record.addTime" mode="datetime" />
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              icon: 'mdi:truck-delivery',
              label: '发货',
              color: 'warning',
              onClick: sendPackage.bind(null, record),
            },
            {
              icon: 'mdi:information-outline',
              label: '详情',
              onClick: () => {
                go(
                  `/order/list/detail/${record.orderSn}?brandId=${record.brandId}&id=${record.id}`,
                );
              },
            },
            {
              icon: 'mdi:printer-outline',
              label: '打印',
              color: 'error',
              onClick: printDetail.bind(null, record),
            },
          ]"
        />
      </template>
    </BasicTable>
    <ConfirmModal @register="registerConfirmModal" @reload="reload" />
    <PrintModal @register="registerPrintModal" @reload="reload" />
  </div>
</template>
<script lang="ts">
  import { defineComponent } from 'vue';
  import {
    BasicTable,
    useTable,
    BasicColumn,
    FormProps,
    TableAction,
    TableImg,
  } from '/@/components/Table';
  import { useMessage } from '/@/hooks/web/useMessage';

  import { ListApi, BrandListApi, GetOrderInfoApi, exportExcelApi } from '/@/api/order/list';
  import { useI18n } from '/@/hooks/web/useI18n';
  // import { useCopyToClipboard } from '/@/hooks/web/useCopyToClipboard';
  import { useGo } from '/@/hooks/web/usePage';
  import { Time } from '/@/components/Time';
  import { PopConfirmButton } from '/@/components/Button';

  import { useModal } from '/@/components/Modal';
  import ConfirmModal from './confirmModal.vue';
  import PrintModal from './printModal.vue';
  import {
    downloadByUrl,
    // downloadByData,
    // downloadByBase64,
    // downloadByOnlineUrl,
  } from '/@/utils/file/download';

  export default defineComponent({
    components: {
      BasicTable,
      TableAction,
      TableImg,
      Time,
      PopConfirmButton,
      ConfirmModal,
      PrintModal,
    },
    setup() {
      const { createMessage } = useMessage();
      const go = useGo();
      const { t } = useI18n();
      const columns: BasicColumn[] = [
        {
          title: 'ID',
          dataIndex: 'id',
          fixed: 'left',
          width: 60,
        },
        {
          title: '订单号',
          dataIndex: 'orderSn',
          ellipsis: false,
          width: 180,
        },
        {
          title: '会员昵称',
          dataIndex: 'nickName',
          width: 80,
        },
        {
          title: 'VR场景',
          dataIndex: 'brandName',
          width: 80,
        },
        {
          title: '订单类型',
          dataIndex: 'orderType',
          slots: { customRender: 'orderType' },
          sorter: true,
          width: 80,
        },
        {
          title: '订单状态',
          dataIndex: 'orderStatus',
          sorter: true,
          slots: { customRender: 'orderStatus' },
          width: 80,
        },
        {
          title: '发货状态',
          dataIndex: 'shippingStatus',
          sorter: true,
          slots: { customRender: 'shippingStatus' },
          width: 80,
        },
        {
          title: '付款状态',
          dataIndex: 'payStatus',
          slots: { customRender: 'payStatus' },
          width: 60,
        },
        {
          title: '快递公司',
          dataIndex: 'shipingName',
          width: 60,
        },
        {
          title: '快递单号',
          dataIndex: 'shippingNo',
          width: 80,
        },
        {
          title: '实际支付金额',
          dataIndex: 'actualPrice',
          width: 80,
        },
        {
          title: '下单时间',
          dataIndex: 'addTime',
          width: 120,
          slots: { customRender: 'addTime' },
        },
        {
          title: '操作',
          dataIndex: '',
          slots: { customRender: 'action' },
          fixed: 'right',
          align: 'center',
          width: 230,
        },
      ];

      const searchForm: Partial<FormProps> = {
        labelWidth: 100,
        schemas: [
          {
            field: 'orderSn',
            label: '订单号',
            component: 'Input',
            colProps: {
              xl: 5,
              xxl: 5,
            },
          },
          {
            field: 'orderStatus',
            label: '订单状态',
            component: 'Select',
            colProps: {
              xl: 5,
              xxl: 5,
            },
            componentProps: {
              options: [
                {
                  label: '全部订单',
                  value: '',
                  key: '1',
                },
                {
                  label: '待付款',
                  value: '0',
                  key: '2',
                },
                {
                  label: '订单已取消',
                  value: '101',
                  key: '3',
                },
                {
                  label: '订单已付款',
                  value: '201',
                  key: '4',
                },
                {
                  label: '订单已发货',
                  value: '1',
                  key: '5',
                },
                {
                  label: '订单已收货',
                  value: '2',
                  key: '6',
                },
                {
                  label: '完成',
                  value: '501',
                  key: '7',
                },
              ],
            },
          },
          {
            field: 'brandId',
            label: 'VR场景',
            component: 'ApiSelect',
            componentProps: {
              api: BrandListApi,
              // resultField: 'list',
              numberToString: true,
              labelField: 'name',
              valueField: 'id',
              immediate: true,
              params: {
                page: 1,
                limit: 1000,
              },
            },
            colProps: {
              xl: 5,
              xxl: 5,
            },
          },
        ],
      };

      const [registerConfirmModal, { openModal: openConfirmModal }] = useModal();

      const [registerPrintModal, { openModal: openPrintModal }] = useModal();

      const [registerTable, { getSelectRowKeys, getSelectRows, reload }] = useTable({
        title: '订单列表',
        api: ListApi,
        columns: columns,
        useSearchForm: true,
        formConfig: searchForm,
        clickToRowSelect: false,
        showTableSetting: true,
        tableSetting: { fullScreen: true },
        showIndexColumn: false,
        rowKey: 'id',
        pagination: { pageSize: 20 },
        ellipsis: false,
        fetchSetting: {
          pageField: 'page',
          sizeField: 'limit',
          listField: 'list',
          totalField: 'totalCount',
        },
        bordered: true,
      });

      function renderOrderTypeLabel(type: number): string {
        switch (type) {
          case 0:
            return '立即购买';
          case 1:
            return '延后购买';
          default:
            return '立即购买';
        }
      }
      function renderOrderStatusLabel(type: number): string {
        switch (type) {
          case 0:
            return '待付款';
          case 101:
            return '已取消';
          case 201:
            return '已付款';
          case 1:
            return '已发货';
          case 2:
            return '已收货';
          case 501:
            return '完成';
          default:
            return '';
        }
      }
      function rendershippingStatusLabel(type: number): string {
        switch (type) {
          case 0:
            return '未发货';
          case 1:
            return '已发货';
          default:
            return '';
        }
      }
      function renderpayStatusLabel(type: number): string {
        switch (type) {
          case 0:
            return '未付款';
          case 1:
            return '已付款';
          default:
            return '';
        }
      }
      // function onSelectChange(selectedRowKeys: (string | number)[]) {
      //   console.log(selectedRowKeys);
      //   // checkedKeys.value = selectedRowKeys;
      // }
      function sendPackage(record: Recordable) {
        openConfirmModal(true, record);
      }
      function handleConfirmReceive() {
        const keys = getSelectRowKeys();
        if (keys.length === 0) {
          createMessage.info(t('modal.atLeastOne'));
          return;
        }
      }
      async function printDetail(record: Recordable) {
        console.log('record', record);
        const orderInfo = await GetOrderInfoApi({
          id: record.id,
          brandId: record.brandId,
        });
        console.log('orderInfo', orderInfo);
        openPrintModal(true, orderInfo);
      }
      async function exportExcel() {
        const rows = getSelectRows();
        if (rows.length === 0) {
          createMessage.info(t('modal.atLeastOne'));
          return;
        }

        const data = rows.reduce((pre, current) => pre.concat(current['orderSn']), []).join(',');
        console.log('data', data);
        const res = await exportExcelApi({
          orderSnList: data,
        });
        if (res.url) {
          downloadByUrl({
            url: res.url,
            target: '_self',
          });
        }
      }

      return {
        registerTable,
        createMessage,
        t,
        go,
        renderOrderTypeLabel,
        renderOrderStatusLabel,
        rendershippingStatusLabel,
        renderpayStatusLabel,
        sendPackage,
        // onSelectChange,
        handleConfirmReceive,
        registerConfirmModal,
        reload,
        printDetail,
        registerPrintModal,
        exportExcel,
      };
    },
  });
</script>
